unit CannyMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ExtDlgs, ComCtrls, Jpeg;

type
  TFrmDemoMain = class(TForm)
    Panel1: TPanel;
    btnDoOpenBMP: TButton;
    GroupBox1: TGroupBox;
    Panel2: TPanel;
    Splitter1: TSplitter;
    ScrollBox1: TScrollBox;
    imgOriginal: TImage;
    ScrollBox2: TScrollBox;
    imgResized: TImage;
    OpenPictureDialog1: TOpenPictureDialog;
    ComboStep: TComboBox;
    Label5: TLabel;
    Label6: TLabel;
    ComboMap: TComboBox;
    EAdd: TEdit;
    Label7: TLabel;
    Button2: TButton;
    SavePictureDialog1: TSavePictureDialog;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    ERadius: TEdit;
    ETheta: TEdit;
    Button1: TButton;
    GroupBox3: TGroupBox;
    Label3: TLabel;
    Label4: TLabel;
    ELow: TEdit;
    EHigh: TEdit;
    procedure btnDoOpenBMPClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ComboChange(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  FrmDemoMain: TFrmDemoMain;

implementation

uses CannySub;

{$R *.dfm}

// t@C̃I[v jpg ƃrbg}bv
procedure TFrmDemoMain.btnDoOpenBMPClick(Sender: TObject);
var
  name: string;
  jpg:  tjpegimage;
begin
  if not OpenPictureDialog1.Execute then exit;
  name := OpenPictureDialog1.FileName;

  if lowercase(extractfileext(name)) = '.bmp' then
      imgOriginal.Picture.Bitmap.LoadFromFile(Name);
  if lowercase(extractfileext(name)) ='.jpg' then
    begin
      jpg:=tjpegimage.Create;
      jpg.LoadFromFile(name);

      imgOriginal.Picture.Bitmap.Assign(jpg);
      jpg.Free;
    end;
  Button1.Enabled := True;
  ComboMap.Enabled := True;
  ComboStep.Enabled := True;
end;

// Canny vZX
procedure TFrmDemoMain.Button1Click(Sender: TObject);
var
  theta   : double;
  radius  : integer;
  l, h    : Smallint;
  a       : Smallint;
  check   : integer;
begin
  Button1.Enabled := False;
  Button2.Enabled := False;
  ComboMap.Enabled := False;
  ComboStep.Enabled := False;
  application.ProcessMessages;
  if not trystrtoint(ERadius.Text, radius) then begin   // KEVAtB^[a
    radius := 3;
    ERadius.Text := '3';
  end;
  if radius < 1 then begin
    radius := 1;
    ERadius.Text := '1';
  end;
  if radius > 20 then begin
    radius := 20;
    ERadius.Text := '20';
  end;

  if not trystrtoFloat(ETheta.Text, theta) then begin   // thetaƂȂĂ܂siguma()ʓIł
    theta  := 1.0;
    ETheta.Text := '1.0';
  end;
  if theta <= 0 then begin
    theta  := 1.0;
    ETheta.Text := '1.0';
  end;
  if theta > 10 then begin
    theta  := 10;
    ETheta.Text := '10';
  end;

  val(ELow.Text, l, Check);                             // qXeVX臏̒Ⴂ̒l
  if Check <> 0 then begin
    l := 30;
    ELow.Text := '30';
  end;
  if l < 0 then  begin
    l := 0;
    ELow.Text := '0';
  end;
  if l > 255 then  begin
    l := 255;
    ELow.Text := '255';
  end;

  val(EHigh.Text, h, Check);                            // qXeVX臏̍̒l
  if Check <> 0 then begin
    h := 60;
    EHigh.Text := '60';
  end;
  if h < l then begin
    h := l;
    EHigh.Text := ELow.Text;
  end;
  if h > 255 then begin
    h := 255;
    EHigh.Text := '255';
  end;

  val(EAdd.Text, a, Check);                             // ǉGbW臒l
  if Check <> 0 then begin
    a := 10;
    EAdd.Text := '10';
  end;
  if a < 0 then begin
    a := 0;
    EAdd.Text := '0';
  end;
  if a > 1442 then begin
    a := 1442;
    EAdd.Text := '1442';
  end;
  // Canny vZX
  Canny(imgOriginal.Picture.Bitmap, imgResized.Picture.Bitmap, radius, theta, l, h, a,
        ComboMap.ItemIndex, ComboStep.ItemIndex);
  imgResized.Invalidate;                          // ĕ`
  Button2.Enabled := True;
  Button1.Enabled := True;
  ComboMap.Enabled := True;
  ComboStep.Enabled := True;
end;

// vZX̑I
procedure TFrmDemoMain.ComboChange(Sender: TObject);
begin
  Button1Click(self);
end;

// ݒ
procedure TFrmDemoMain.FormCreate(Sender: TObject);
begin
  Button1.Enabled := False;
  Button2.Enabled := False;
  ComboMap.Enabled := False;
  ComboStep.Enabled := False;
end;

// t@Cۑ Jpg ́@rbg}bv
procedure TFrmDemoMain.Button2Click(Sender: TObject);
var
  name: string;
  jpg: tjpegimage;
begin
  if not SavePictureDialog1.Execute then exit;
  name := SavePictureDialog1.FileName;
  case SavePictureDialog1.FilterIndex of
    1: name := ChangeFileExt(name,'.jpg');
    2: name := ChangeFileExt(name,'.bmp');
  end;
  if Length(ExtractFileName(name)) <= 4 then exit;
  if lowercase(extractfileext(name)) = '.bmp' then
    imgResized.Picture.Bitmap.SaveToFile(Name);
  if lowercase(extractfileext(name)) = '.jpg' then
  begin
    jpg:=tjpegimage.Create;
    jpg.Assign(imgResized.Picture.Bitmap);
    jpg.SaveToFile(name);
    jpg.Free;
  end;
end;

end.
